Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 75772)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -1891,271 +2287,122 @@
 }
 
 void free_write_data_stripes(write_data_context* wtc) {
-    LIST_ENTRY *le, *le2, *nextle;
-    
+    LIST_ENTRY* le;
+    PMDL last_mdl = NULL;
+
+    if (wtc->parity1_mdl) {
+        if (wtc->parity1_mdl->MdlFlags & MDL_PAGES_LOCKED)
+            MmUnlockPages(wtc->parity1_mdl);
+
+        IoFreeMdl(wtc->parity1_mdl);
+    }
+
+    if (wtc->parity2_mdl) {
+        if (wtc->parity2_mdl->MdlFlags & MDL_PAGES_LOCKED)
+            MmUnlockPages(wtc->parity2_mdl);
+
+        IoFreeMdl(wtc->parity2_mdl);
+    }
+
+    if (wtc->mdl) {
+        if (wtc->mdl->MdlFlags & MDL_PAGES_LOCKED)
+            MmUnlockPages(wtc->mdl);
+
+        IoFreeMdl(wtc->mdl);
+    }
+
+    if (wtc->parity1)
+        ExFreePool(wtc->parity1);
+
+    if (wtc->parity2)
+        ExFreePool(wtc->parity2);
+
+    if (wtc->scratch)
+        ExFreePool(wtc->scratch);
+
     le = wtc->stripes.Flink;
     while (le != &wtc->stripes) {
         write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-        
-        if (stripe->Irp) {
-            if (stripe->device->devobj->Flags & DO_DIRECT_IO) {
-                MmUnlockPages(stripe->Irp->MdlAddress);
-                IoFreeMdl(stripe->Irp->MdlAddress);
-            }
+
+        if (stripe->mdl && stripe->mdl != last_mdl) {
+            if (stripe->mdl->MdlFlags & MDL_PAGES_LOCKED)
+                MmUnlockPages(stripe->mdl);
+
+            IoFreeMdl(stripe->mdl);
         }
-        
+
+        last_mdl = stripe->mdl;
+
         le = le->Flink;
     }
-    
-    le = wtc->stripes.Flink;
-    while (le != &wtc->stripes) {
-        write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-        
-        nextle = le->Flink;
 
-        if (stripe->buf && stripe->need_free) {
-            ExFreePool(stripe->buf);
-            
-            le2 = le->Flink;
-            while (le2 != &wtc->stripes) {
-                write_data_stripe* s2 = CONTAINING_RECORD(le2, write_data_stripe, list_entry);
-                
-                if (s2->buf == stripe->buf)
-                    s2->buf = NULL;
-                
-                le2 = le2->Flink;
-            }
-            
-        }
-        
+    while (!IsListEmpty(&wtc->stripes)) {
+        write_data_stripe* stripe = CONTAINING_RECORD(RemoveHeadList(&wtc->stripes), write_data_stripe, list_entry);
+
         ExFreePool(stripe);
-        
-        le = nextle;
     }
 }
 
+void add_extent(_In_ fcb* fcb, _In_ LIST_ENTRY* prevextle, _In_ __drv_aliasesMem extent* newext) {
+    LIST_ENTRY* le = prevextle->Flink;
+
+    while (le != &fcb->extents) {
+        extent* ext = CONTAINING_RECORD(le, extent, list_entry);
+
+        if (ext->offset >= newext->offset) {
+            InsertHeadList(ext->list_entry.Blink, &newext->list_entry);
+            return;
+        }
+
+        le = le->Flink;
+    }
+
+    InsertTailList(&fcb->extents, &newext->list_entry);
+}
+
 NTSTATUS excise_extents(device_extension* Vcb, fcb* fcb, UINT64 start_data, UINT64 end_data, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
     LIST_ENTRY* le;
-    
+
     le = fcb->extents.Flink;
 
     while (le != &fcb->extents) {
         LIST_ENTRY* le2 = le->Flink;
         extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-        EXTENT_DATA* ed = ext->data;
-        EXTENT_DATA2* ed2;
+        EXTENT_DATA* ed = &ext->extent_data;
+        EXTENT_DATA2* ed2 = NULL;
         UINT64 len;
-        
+
         if (!ext->ignore) {
-            if (ext->datalen < sizeof(EXTENT_DATA)) {
-                ERR("extent at %llx was %u bytes, expected at least %u\n", ext->offset, ext->datalen, sizeof(EXTENT_DATA));
-                Status = STATUS_INTERNAL_ERROR;
-                goto end;
-            }
-            
-            if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) { 
-                if (ext->datalen < sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
-                    ERR("extent at %llx was %u bytes, expected at least %u\n", ext->offset, ext->datalen, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2));
-                    Status = STATUS_INTERNAL_ERROR;
-                    goto end;
-                }
-                
+            if (ed->type != EXTENT_TYPE_INLINE)
                 ed2 = (EXTENT_DATA2*)ed->data;
-            }
-            
+
             len = ed->type == EXTENT_TYPE_INLINE ? ed->decoded_size : ed2->num_bytes;
-            
+
             if (ext->offset < end_data && ext->offset + len > start_data) {
                 if (ed->type == EXTENT_TYPE_INLINE) {
                     if (start_data <= ext->offset && end_data >= ext->offset + len) { // remove all
                         remove_fcb_extent(fcb, ext, rollback);
-                        
+
                         fcb->inode_item.st_blocks -= len;
                         fcb->inode_item_changed = TRUE;
-                    } else if (start_data <= ext->offset && end_data < ext->offset + len) { // remove beginning
-                        EXTENT_DATA* ned;
-                        UINT64 size;
-                        extent* newext;
-                        
-                        size = len - (end_data - ext->offset);
-                        
-                        ned = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + size, ALLOC_TAG);
-                        if (!ned) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        newext = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
-                        if (!newext) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(ned);
-                            goto end;
-                        }
-                        
-                        ned->generation = Vcb->superblock.generation;
-                        ned->decoded_size = size;
-                        ned->compression = ed->compression;
-                        ned->encryption = ed->encryption;
-                        ned->encoding = ed->encoding;
-                        ned->type = ed->type;
-                        
-                        RtlCopyMemory(&ned->data[0], &ed->data[end_data - ext->offset], size);
-                        
-                        newext->offset = end_data;
-                        newext->data = ned;
-                        newext->datalen = sizeof(EXTENT_DATA) - 1 + size;
-                        newext->unique = ext->unique;
-                        newext->ignore = FALSE;
-                        newext->inserted = TRUE;
-                        newext->csum = NULL;
-                        InsertHeadList(&ext->list_entry, &newext->list_entry);
-                        
-                        remove_fcb_extent(fcb, ext, rollback);
-                        
-                        fcb->inode_item.st_blocks -= end_data - ext->offset;
-                        fcb->inode_item_changed = TRUE;
-                    } else if (start_data > ext->offset && end_data >= ext->offset + len) { // remove end
-                        EXTENT_DATA* ned;
-                        UINT64 size;
-                        extent* newext;
-                        
-                        size = start_data - ext->offset;
-                        
-                        ned = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + size, ALLOC_TAG);
-                        if (!ned) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        newext = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
-                        if (!newext) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(ned);
-                            goto end;
-                        }
-                        
-                        ned->generation = Vcb->superblock.generation;
-                        ned->decoded_size = size;
-                        ned->compression = ed->compression;
-                        ned->encryption = ed->encryption;
-                        ned->encoding = ed->encoding;
-                        ned->type = ed->type;
-                        
-                        RtlCopyMemory(&ned->data[0], &ed->data[0], size);
-                        
-                        newext->offset = ext->offset;
-                        newext->data = ned;
-                        newext->datalen = sizeof(EXTENT_DATA) - 1 + size;
-                        newext->unique = ext->unique;
-                        newext->ignore = FALSE;
-                        newext->inserted = TRUE;
-                        newext->csum = NULL;
-                        InsertHeadList(&ext->list_entry, &newext->list_entry);
-                        
-                        remove_fcb_extent(fcb, ext, rollback);
-                        
-                        fcb->inode_item.st_blocks -= ext->offset + len - start_data;
-                        fcb->inode_item_changed = TRUE;
-                    } else if (start_data > ext->offset && end_data < ext->offset + len) { // remove middle
-                        EXTENT_DATA *ned1, *ned2;
-                        UINT64 size;
-                        extent *newext1, *newext2;
-                        
-                        size = start_data - ext->offset;
-                        
-                        ned1 = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + size, ALLOC_TAG);
-                        if (!ned1) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        newext1 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
-                        if (!newext1) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(ned1);
-                            goto end;
-                        }
-                        
-                        ned1->generation = Vcb->superblock.generation;
-                        ned1->decoded_size = size;
-                        ned1->compression = ed->compression;
-                        ned1->encryption = ed->encryption;
-                        ned1->encoding = ed->encoding;
-                        ned1->type = ed->type;
-                        
-                        RtlCopyMemory(&ned1->data[0], &ed->data[0], size);
-
-                        newext1->offset = ext->offset;
-                        newext1->data = ned1;
-                        newext1->datalen = sizeof(EXTENT_DATA) - 1 + size;
-                        newext1->unique = ext->unique;
-                        newext1->ignore = FALSE;
-                        newext1->inserted = TRUE;
-                        newext1->csum = NULL;
-                        
-                        size = ext->offset + len - end_data;
-                        
-                        ned2 = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + size, ALLOC_TAG);
-                        if (!ned2) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(ned1);
-                            ExFreePool(newext1);
-                            goto end;
-                        }
-                        
-                        newext2 = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
-                        if (!newext2) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(ned1);
-                            ExFreePool(newext1);
-                            ExFreePool(ned2);
-                            goto end;
-                        }
-                        
-                        ned2->generation = Vcb->superblock.generation;
-                        ned2->decoded_size = size;
-                        ned2->compression = ed->compression;
-                        ned2->encryption = ed->encryption;
-                        ned2->encoding = ed->encoding;
-                        ned2->type = ed->type;
-                        
-                        RtlCopyMemory(&ned2->data[0], &ed->data[end_data - ext->offset], size);
-                        
-                        newext2->offset = end_data;
-                        newext2->data = ned2;
-                        newext2->datalen = sizeof(EXTENT_DATA) - 1 + size;
-                        newext2->unique = ext->unique;
-                        newext2->ignore = FALSE;
-                        newext2->inserted = TRUE;
-                        newext2->csum = NULL;
-                        
-                        InsertHeadList(&ext->list_entry, &newext1->list_entry);
-                        InsertHeadList(&newext1->list_entry, &newext2->list_entry);
-                        
-                        remove_fcb_extent(fcb, ext, rollback);
-                        
-                        fcb->inode_item.st_blocks -= end_data - start_data;
-                        fcb->inode_item_changed = TRUE;
+                    } else {
+                        ERR("trying to split inline extent\n");
+#ifdef DEBUG_PARANOID
+                        int3;
+#endif
+                        return STATUS_INTERNAL_ERROR;
                     }
-                } else if (ed->type == EXTENT_TYPE_REGULAR || ed->type == EXTENT_TYPE_PREALLOC) {
+                } else if (ed->type != EXTENT_TYPE_INLINE) {
                     if (start_data <= ext->offset && end_data >= ext->offset + len) { // remove all
                         if (ed2->size != 0) {
                             chunk* c;
-                            
+
                             fcb->inode_item.st_blocks -= len;
                             fcb->inode_item_changed = TRUE;
-                            
+
                             c = get_chunk_from_address(Vcb, ed2->address);
-                            
+
                             if (!c) {
                                 ERR("get_chunk_from_address(%llx) failed\n", ed2->address);
                             } else {
@@ -2167,41 +2414,32 @@
                                 }
                             }
                         }
-                        
+
                         remove_fcb_extent(fcb, ext, rollback);
                     } else if (start_data <= ext->offset && end_data < ext->offset + len) { // remove beginning
-                        EXTENT_DATA* ned;
                         EXTENT_DATA2* ned2;
                         extent* newext;
-                        
+
                         if (ed2->size != 0) {
                             fcb->inode_item.st_blocks -= end_data - ext->offset;
                             fcb->inode_item_changed = TRUE;
                         }
-                        
-                        ned = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
-                        if (!ned) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        newext = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+
+                        newext = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
                         if (!newext) {
                             ERR("out of memory\n");
                             Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(ned);
                             goto end;
                         }
-                        
-                        ned2 = (EXTENT_DATA2*)&ned->data[0];
-                        
-                        ned->generation = Vcb->superblock.generation;
-                        ned->decoded_size = ed->decoded_size;
-                        ned->compression = ed->compression;
-                        ned->encryption = ed->encryption;
-                        ned->encoding = ed->encoding;
-                        ned->type = ed->type;
+
+                        ned2 = (EXTENT_DATA2*)newext->extent_data.data;
+
+                        newext->extent_data.generation = Vcb->superblock.generation;
+                        newext->extent_data.decoded_size = ed->decoded_size;
+                        newext->extent_data.compression = ed->compression;
+                        newext->extent_data.encryption = ed->encryption;
+                        newext->extent_data.encoding = ed->encoding;
+                        newext->extent_data.type = ed->type;
                         ned2->address = ed2->address;
                         ned2->size = ed2->size;
                         ned2->offset = ed2->offset + (end_data - ext->offset);
@@ -2208,76 +2446,64 @@
                         ned2->num_bytes = ed2->num_bytes - (end_data - ext->offset);
 
                         newext->offset = end_data;
-                        newext->data = ned;
                         newext->datalen = sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2);
                         newext->unique = ext->unique;
                         newext->ignore = FALSE;
                         newext->inserted = TRUE;
-                        
+
                         if (ext->csum) {
                             if (ed->compression == BTRFS_COMPRESSION_NONE) {
-                                newext->csum = ExAllocatePoolWithTag(PagedPool, ned2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
+                                newext->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(ned2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
                                 if (!newext->csum) {
                                     ERR("out of memory\n");
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
-                                    ExFreePool(ned);
                                     ExFreePool(newext);
                                     goto end;
                                 }
-                                
+
                                 RtlCopyMemory(newext->csum, &ext->csum[(end_data - ext->offset) / Vcb->superblock.sector_size],
-                                              ned2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size);
+                                              (ULONG)(ned2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size));
                             } else {
-                                newext->csum = ExAllocatePoolWithTag(PagedPool, ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
+                                newext->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
                                 if (!newext->csum) {
                                     ERR("out of memory\n");
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
-                                    ExFreePool(ned);
                                     ExFreePool(newext);
                                     goto end;
                                 }
-                                
-                                RtlCopyMemory(newext->csum, ext->csum, ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size);
+
+                                RtlCopyMemory(newext->csum, ext->csum, (ULONG)(ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size));
                             }
                         } else
                             newext->csum = NULL;
-                        
-                        InsertHeadList(&ext->list_entry, &newext->list_entry);
-                        
+
+                        add_extent(fcb, &ext->list_entry, newext);
+
                         remove_fcb_extent(fcb, ext, rollback);
                     } else if (start_data > ext->offset && end_data >= ext->offset + len) { // remove end
-                        EXTENT_DATA* ned;
                         EXTENT_DATA2* ned2;
                         extent* newext;
-                        
+
                         if (ed2->size != 0) {
                             fcb->inode_item.st_blocks -= ext->offset + len - start_data;
                             fcb->inode_item_changed = TRUE;
                         }
-                        
-                        ned = ExAllocatePoolWithTag(PagedPool, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
-                        if (!ned) {
-                            ERR("out of memory\n");
-                            Status = STATUS_INSUFFICIENT_RESOURCES;
-                            goto end;
-                        }
-                        
-                        newext = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+
+                        newext = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2), ALLOC_TAG);
                         if (!newext) {
                             ERR("out of memory\n");
                             Status = STATUS_INSUFFICIENT_RESOURCES;
-                            ExFreePool(ned);
                             goto end;
                         }
-                        
-                        ned2 = (EXTENT_DATA2*)&ned->data[0];
-                        
-                        ned->generation = Vcb->superblock.generation;
-                        ned->decoded_size = ed->decoded_size;
-                        ned->compression = ed->compression;
-                        ned->encryption = ed->encryption;
-                        ned->encoding = ed->encoding;
-                        ned->type = ed->type;
+
+                        ned2 = (EXTENT_DATA2*)newext->extent_data.data;
+
+                        newext->extent_data.generation = Vcb->superblock.generation;
+                        newext->extent_data.decoded_size = ed->decoded_size;
+                        newext->extent_data.compression = ed->compression;
+                        newext->extent_data.encryption = ed->encryption;
+                        newext->extent_data.encoding = ed->encoding;
+                        newext->extent_data.type = ed->type;
                         ned2->address = ed2->address;
                         ned2->size = ed2->size;
                         ned2->offset = ed2->offset;
@@ -2284,55 +2510,51 @@
                         ned2->num_bytes = start_data - ext->offset;
 
                         newext->offset = ext->offset;
-                        newext->data = ned;
                         newext->datalen = sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2);
                         newext->unique = ext->unique;
                         newext->ignore = FALSE;
                         newext->inserted = TRUE;
-                        
+
                         if (ext->csum) {
                             if (ed->compression == BTRFS_COMPRESSION_NONE) {
-                                newext->csum = ExAllocatePoolWithTag(PagedPool, ned2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
+                                newext->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(ned2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
                                 if (!newext->csum) {
                                     ERR("out of memory\n");
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
-                                    ExFreePool(ned);
                                     ExFreePool(newext);
                                     goto end;
                                 }
-                                
-                                RtlCopyMemory(newext->csum, ext->csum, ned2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size);
+
+                                RtlCopyMemory(newext->csum, ext->csum, (ULONG)(ned2->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size));
                             } else {
-                                newext->csum = ExAllocatePoolWithTag(PagedPool, ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
+                                newext->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
                                 if (!newext->csum) {
                                     ERR("out of memory\n");
                                     Status = STATUS_INSUFFICIENT_RESOURCES;
-                                    ExFreePool(ned);
                                     ExFreePool(newext);
                                     goto end;
                                 }
-                                
-                                RtlCopyMemory(newext->csum, ext->csum, ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size);
+
+                                RtlCopyMemory(newext->csum, ext->csum, (ULONG)(ed2->size * sizeof(UINT32) / Vcb->superblock.sector_size));
                             }
                         } else
                             newext->csum = NULL;
-                        
+
                         InsertHeadList(&ext->list_entry, &newext->list_entry);
-                        
+
                         remove_fcb_extent(fcb, ext, rollback);
                     } else if (start_data > ext->offset && end_data < ext->offset + len) { // remove middle
-                        EXTENT_DATA *neda, *nedb;
                         EXTENT_DATA2 *neda2, *nedb2;
                         extent *newext1, *newext2;
-                        
+
                         if (ed2->size != 0) {
                             chunk* c;
-                            
+
                             fcb->inode_item.st_blocks -= end_data - start_data;
                             fcb->inode_item_changed = TRUE;
-                            
+
                             c = get_chunk_from_address(Vcb, ed2->address);
-                            
+
                             if (!c) {
                                 ERR("get_chunk_from_address(%llx) failed\n", ed2->address);
                             } else {
